package com.ibm.ccl.ua.generators.sitexml;

import java.util.Hashtable;

import org.eclipse.core.runtime.IConfigurationElement;
import org.eclipse.core.runtime.IExtension;
import org.eclipse.core.runtime.IExtensionPoint;
import org.eclipse.core.runtime.Platform;

public class CategoryDependencyHandler {

	private Hashtable categoryDependencies = new Hashtable();
	
	public CategoryDependencyHandler()
	{
		//Initialize hashtable based off of extension
		String EXT_PT = "com.ibm.ccl.ua.generators.sitexml.categorydependency"; //$NON-NLS-1$ 
		
		// Get all products that contribute to the category dependency extension point
		IExtension[] extensions;
		
		IExtensionPoint dependencyExtension = Platform.getExtensionRegistry().getExtensionPoint(EXT_PT);
		
		if(dependencyExtension!=null)
		{
			extensions = dependencyExtension.getExtensions();
			
			// Loop through the array of extensions, pull out the data, and populate
			// our hashtable with the category dependecies
			
			String currCategory="",currCategoryDependency = ""; //$NON-NLS-1$//$NON-NLS-2$
			
			//Get total number of extensions
			int totalContributers = extensions.length;
	
			for (int i = 0; i < totalContributers; i++) {
				IExtension extension = extensions[i];
				IConfigurationElement[] elements = extension
						.getConfigurationElements();
	
					for (int j = 0; j < elements.length; j++) 
					{
						IConfigurationElement configurationElement = elements[j];
					
						//$NON-NLS-1$
						currCategory = configurationElement.getAttribute("category_name");
						currCategoryDependency = configurationElement.getAttribute("category_dependency");
						
						//Add From/To pair to the hash table
						categoryDependencies.put(currCategory, currCategoryDependency);
											
				}
			}
		}
	}
	
	public Hashtable getCategoryDependencyHash()
	{
		return categoryDependencies;
	}
	
}
