package com.ibm.ccl.ua.generators.sitexml;

/*******************************************************************************
 * Copyright (c) 2000, 2007 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     IBM Corporation - initial API and implementation
 *******************************************************************************/

import java.io.IOException;
import java.util.Enumeration;
import java.util.Hashtable;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
/**
 * Servlet to handle live help action requests
 */
public class CategoryDependencyServlet extends HttpServlet {
	private static final long serialVersionUID = 1L;
	CategoryDependencyHandler dependencyHandler = new CategoryDependencyHandler();
	Hashtable categoryDependencies = dependencyHandler.getCategoryDependencyHash();
	private static String categoryDelimeter="$";
	
	/**
	 */
	public void init() throws ServletException {
		
	}

	/**
	 * Called by the server (via the <code>service</code> method) to allow a
	 * servlet to handle a GET request.
	 */
	protected void doGet(HttpServletRequest req, HttpServletResponse resp)
			throws ServletException, IOException {
		
		
		//req.setCharacterEncoding("UTF-8"); //$NON-NLS-1$
		resp.setContentType("text/html"); //$NON-NLS-1$
		resp.setHeader("Cache-Control", "no-store, no-cache, must-revalidate");
		String categoryDependencyList="";
		Enumeration dependencyKeys= categoryDependencies.keys();
		String currCategoryKey,currCategoryDependency;
		while(dependencyKeys.hasMoreElements())
		{
			currCategoryKey=(String)dependencyKeys.nextElement();
			currCategoryDependency=(String)categoryDependencies.get(currCategoryKey);
			
			//Entry not yet in map list.  Add to list.
				if(categoryDependencyList.equals(""))
				{
					categoryDependencyList=currCategoryKey+categoryDelimeter+currCategoryDependency;
				}
				else
				{
					categoryDependencyList=categoryDependencyList+categoryDelimeter+currCategoryKey+categoryDelimeter+currCategoryDependency;
				}
		}		
		//if(categoryDependencyList.equals(""))
			//categoryDependencyList="none";
		categoryDependencyList = categoryDependencyList+"\n";
		resp.getWriter().write(categoryDependencyList);
		
	
				
	}
	/**
	 * 
	 * Called by the server (via the <code>service</code> method) to allow a
	 * servlet to handle a POST request.
	 * 
	 * Handle the search requests,
	 *  
	 */
	protected void doPost(HttpServletRequest req, HttpServletResponse resp)
			throws ServletException, IOException {
		doGet(req, resp);
	}
	
	
}

